
/* Written by Michael E. Kounavis, Commmunications Technology Lab,
   Intel Corporation, 2008
 */


#ifndef VORTEX_CORE_H
#define VORTEX_CORE_H

#include "int_types.h"

int
vortex(uint8_t *data, 
			   uint64_t *length, 
			   uint8_t *hash, 
			   uint32_t type);


int
tunable_vortex(uint8_t  *data, 
			   uint64_t *length, 
			   uint8_t  *hash, 
			   uint32_t type,
			   uint8_t  number_of_rounds,
			   uint8_t  mul_type,
			   uint8_t  *a0_b0,
			   uint8_t  *ta_tb,
			   uint8_t  degree_of_diffusion);


int
vortex_224(uint8_t  *data, 
		   uint64_t *length, 
		   uint8_t  *hash, 
		   uint8_t  number_of_rounds,
		   uint8_t  mul_type,
		   uint8_t  *a0_b0,
		   uint8_t  *ta_tb,
		   uint8_t  degree_of_diffusion);


int
vortex_384(uint8_t  *data, 
		   uint64_t *length, 
		   uint8_t  *hash, 
		   uint8_t  number_of_rounds,
		   uint8_t  mul_type,
		   uint8_t  *a0_b0,
		   uint8_t  *ta_tb,
		   uint8_t  degree_of_diffusion);


int
vortex_256(uint8_t  *data, 
		   uint64_t *length_pointer, 
		   uint8_t  *hash, 
		   uint8_t  number_of_rounds,
		   uint8_t  mul_type,
		   uint8_t  *a0_b0,
		   uint8_t  *ta_tb,
		   uint8_t  degree_of_diffusion);


int
vortex_256_block(uint8_t *hash,
				 uint8_t *data,
				 uint8_t number_of_rounds, 
				 uint8_t mul_type);


int
last_vortex_256_block(uint8_t *hash,
					  uint8_t *data,
					  uint8_t number_of_rounds, 
					  uint8_t mul_type,
					  uint8_t degree_of_diffusion);


int
vortex_256_sub_block(uint8_t *hash,
					 uint8_t *data,
					 uint8_t number_of_rounds, 
					 uint8_t mul_type);


int
last_vortex_256_sub_block(uint8_t *hash,
						  uint8_t *data,
						  uint8_t number_of_rounds, 
						  uint8_t mul_type,
						  uint8_t degree_of_diffusion);


int
vma_256(uint8_t *a,
		uint8_t *b,
		uint8_t mul_type);


int
vortex_512(uint8_t  *data, 
		   uint64_t *length_pointer, 
		   uint8_t  *hash, 
		   uint8_t  number_of_rounds,
		   uint8_t  mul_type,
		   uint8_t  *a0_b0,
		   uint8_t  *ta_tb,
		   uint8_t  degree_of_diffusion);


int
vortex_512_block(uint8_t *hash,
				 uint8_t *data,
				 uint8_t number_of_rounds, 
				 uint8_t mul_type);


int
last_vortex_512_block(uint8_t *hash,
					  uint8_t *data,
					  uint8_t number_of_rounds, 
					  uint8_t mul_type,
					  uint8_t degree_of_diffusion);


int
vortex_512_sub_block(uint8_t *hash,
					 uint8_t *data,
					 uint8_t number_of_rounds, 
					 uint8_t mul_type);



int
last_vortex_512_sub_block(uint8_t *hash,
						  uint8_t *data,
						  uint8_t number_of_rounds, 
						  uint8_t mul_type,
						  uint8_t degree_of_diffusion);


int
vma_512(uint8_t *a,
		uint8_t *b,
		uint8_t mul_type);

int
generate_constants(void);

int
generate_random_tweak_values(void);

int
set_default_parameters(void);


#endif